链接:两数之和
题目描述
给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。
你可以按任意顺序返回答案。
示例:
输入:nums = [3,2,4], target = 6
输出:[1,2]
题解1
这是本人做题时想到的方法,由于题给数组是无序的,因此先进行排序,之后根据有序数列的性质进行简化
sort(a), 令i = 0, j = len(a)
1、如果a[i] + a[j] == target,记录下标,break
2、如果a[i] + a[j] < target, 则i++
3、如果a[i] + a[j] > target ,则j--
class Solution {
public:
vector<int> twoSum(vector<int>& nums, int target)
{
int len = nums.size();
vector<int> ans;
vector<int> temp = nums;
sort(nums.begin(), nums.end());
int i = 0, j = len - 1;
while(i < j)
{
if(nums[i] + nums[j] == target)
{
auto loc1 = find(temp.begin(), temp.end(), nums[i]) ;
auto loc2 = find(temp.begin(), temp.end(), nums[j]) ;
if(loc1 == loc2 && loc1 != temp.end())
loc2 = find(loc1 + 1, temp.end(), nums[j]);
ans.push_back(loc1 - temp.begin()), ans.push_back(loc2 - temp.begin());
break;
}
else if(nums[i] + nums[j] < target)
i++;
else
j--;
}
return ans;
}
};
时间复杂度O(nlogn),空间复杂度O(n)
题解二
这是leetcode官方提供的解法
class Solution {
public:
vector<int> twoSum(vector<int>& nums, int target) {
unordered_map<int, int> hashtable;
for (int i = 0; i < nums.size(); ++i) {
auto it = hashtable.find(target - nums[i]);
if (it != hashtable.end()) {
return {it->second, i};
}
hashtable[nums[i]] = i;
}
return {};
}
};
作者:LeetCode-Solution
链接:https://leetcode.cn/problems/two-sum/solution/liang-shu-zhi-he-by-leetcode-solution/
来源:力扣(LeetCode)
著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。
当遍历到某一元素x
时,需要寻找的元素为target-x
,而要被寻找的元素在之前可能出现过,而查找某一元素是否出现过,直观想法就是利用hashTable